// Please, read the text in comments.
// It explains how to see various features in action

#include "stdafx.h"         // To set or remove a bookmark at the currnet line 
                            // use 'Toggle Bookmark' ('Ctrl'+'F2')
#include <windows.h>
#include <stdio.h>          // To move the cursor between bookmarks
#include <conio.h>          // use 'Next Bookmark' and 'Previous Bookmark'

#define DO_TRACE(bTrace, lpszText)  { if (bTrace) { printf("%s\n",lpszText); } }

class CMyClass              // To find the text string use 'Find' ('Ctrl'+'F')
{                           // Use 'F3', 'Shift'+'F3' hotkeys to find next or previous text entry
public:
    CMyClass(): m_bTrace(FALSE)
    {
        memset(&m_lf,0,sizeof(LOGFONT));
    }
    ~CMyClass()				// To insert or remove a breakpoint click
    {                       // use 'Insert/Remove Breakpoint' ('F9')
        OnDestroy();
    }
    int DoMain()			// To indent text select several lines, press 'Tab' button
    {
        DO_TRACE(m_bTrace,"CMyClass::DoMain ()");
        return 0;			// Change font style, size, and default color.
    }
    const char* GetAppName() const  { return "Example.exe"; }
    inline void EnableTrace(BOOL bTrace = TRUE)  { m_bTrace = bTrace; }

protected:
            BOOL m_bTrace;
            LOGFONT m_lf;

            virtual void OnDestroy()
            {               //  To look definition of a symbol just set mouse focus on it
                DO_TRACE(m_bTrace, "CMyClass::OnDestroy ()");
            }               //  To find out the class members' names type
};                          //  "this->" to open class members' popup list

int main()
//	The entry point for the console application
{
    CMyClass* pMyClass = new CMyClass();    //  To find out the class/struct
                                            //  members' names simple strike '.'
    DO_TRACE(TRUE, pMyClass->GetAppName()); //  after typing its name or just
    int nRet = pMyClass->DoMain();          //  press 'Ctrl'+'Alt'+'T'
    
    delete pMyClass;                        //  To find out the CMyClass->m_lf members'
                                            //  names type "pMyClass->m_lf." to open
    return nRet;                            //  class members' popup list
}
