// CustomEditCtrl.h : header file
//

#if !defined(AFX_CUSTOMEDITCTRL_H__086075A9_8FCA_49AF_A2CD_1F3EB13AFF50__INCLUDED_)
#define AFX_CUSTOMEDITCTRL_H__086075A9_8FCA_49AF_A2CD_1F3EB13AFF50__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//#include "BCGPEditCtrl.h"

/////////////////////////////////////////////////////////////////////////////
// CCustomEditCtrl window

static const DWORD g_dwBreakPointType = g_dwBCGPEdit_FirstUserDefinedMarker;
static const DWORD g_dwColorBreakPointType = g_dwBCGPEdit_FirstUserDefinedMarker << 1;
static const DWORD g_dwHeaderType = g_dwColorBreakPointType << 1;
static const DWORD g_dwColorHeaderType = g_dwHeaderType << 1;
static const DWORD g_dwLineMarkerType = g_dwColorHeaderType << 1;
static const DWORD g_dwColorStaticMarkerType = g_dwLineMarkerType << 1;

class CCustomEditCtrl : public CBCGPEditCtrl
{
// Construction, destruction
public:
	CCustomEditCtrl();
	virtual ~CCustomEditCtrl();

// Attributes
public:

// Operations
public:
	BOOL ToggleBreakpoint(int nCurrRow = -1);
	void RemoveAllBreakpoints();
	BOOL IsEnableBreakpoints() {  return m_bEnableBreakpoints; }
	BOOL EnableBreakpoints(BOOL bFl = TRUE);

	BOOL ToggleStaticMarker(int nCurrRow = -1 );

	BOOL IsEnableFullLine() {  return m_bFullLine; }
	BOOL EnableFullLine(BOOL bFl = TRUE);

	BOOL ToggleLineMarker(int nCurrRow = -1, BOOL bRedraw = TRUE);
	void RemoveLineMarker(BOOL bRedraw = TRUE);
	BOOL MoveLineMarker(int nCurrRow = -1, BOOL bRedraw = TRUE);
	BOOL IsEnableLineMarker() {  return m_bEnableLineMarker; }
	BOOL EnableLineMarker(BOOL bFl = TRUE);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCustomEditCtrl)
	//}}AFX_VIRTUAL

public:
	// Marker Support
	virtual void OnDrawMarker(CDC* pDC, CRect rectMarker, const CBCGPEditMarker* pMarker);

	virtual BOOL CanUpdateMarker (CBCGPEditMarker* pMarker) const
	{
		if (pMarker->m_dwMarkerType & g_dwColorHeaderType ||
			pMarker->m_dwMarkerType & g_dwColorStaticMarkerType)
		{
			return FALSE;
		}

		return TRUE;
	}

	virtual BOOL CanRemoveMarker (CBCGPEditMarker* pMarker) const  
	{
		if (pMarker->m_dwMarkerType & g_dwColorHeaderType ||
			pMarker->m_dwMarkerType & g_dwColorStaticMarkerType)
		{
			return FALSE;
		}

		return TRUE;
	}

protected:
	
// Implementation

	// Generated message map functions
protected:
	//{{AFX_MSG(CCustomEditCtrl)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	BOOL	m_bEnableBreakpoints;
	BOOL	m_bFullLine;
	BOOL	m_bEnableLineMarker;
	BOOL	m_bDragLineMarker;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CUSTOMEDITCTRL_H__086075A9_8FCA_49AF_A2CD_1F3EB13AFF50__INCLUDED_)
