// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Markers.h"

#include "MainFrm.h"
#include "MarkersView.h"
#include "CustomEditCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_MARKERS_TOGGLEBOOKMARK, OnMarkersTogglebookmark)
	ON_COMMAND(ID_MARKERS_NEXTBOOKMARK, OnMarkersNextbookmark)
	ON_COMMAND(ID_MARKERS_PREVIOUSBOOKMARK, OnMarkersPreviousbookmark)
	ON_COMMAND(ID_MARKERS_TOGGLEBREAKPOINT, OnMarkersTogglebreakpoint)
	ON_COMMAND(ID_MARKERS_REMOVE_ALL_BREAKPOINTS, OnMarkersRemoveAllBreakpoints)
	ON_COMMAND(ID_EDIT_FIND, OnEditFind)
	ON_COMMAND(ID_EDIT_FINDNEXT, OnEditFindnext)
	ON_COMMAND(ID_EDIT_FINDPREV, OnEditFindprev)
	ON_COMMAND(ID_MARKERS_STATICMARKER, OnMarkersToggleStaticmarker)
	ON_COMMAND(ID_MARKERS_FULLLINE, OnMarkersFullline)
	ON_UPDATE_COMMAND_UI(ID_MARKERS_FULLLINE, OnUpdateMarkersFullline)
	ON_COMMAND(ID_MARKERS_LINEMARKER, OnMarkersLinemarker)
	ON_UPDATE_COMMAND_UI(ID_MARKERS_LINEMARKER, OnUpdateMarkersLinemarker)
	ON_COMMAND(ID_MARKERS_NEXTDIFF, OnMarkersNextdiff)
	ON_COMMAND(ID_MARKERS_PREVDIFF, OnMarkersPrevdiff)
	ON_WM_DRAWITEM()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CURSORPOS,
	ID_INDICATOR_DELETED,
	ID_INDICATOR_CHANGED,
	ID_INDICATOR_INSERTED,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this)  ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	UINT nID, nStyle;
	int cxWidth;

	m_wndStatusBar.GetPaneInfo( 2, nID, nStyle, cxWidth);
	m_wndStatusBar.SetPaneInfo( 2, nID, SBT_OWNERDRAW, cxWidth);
	m_wndStatusBar.GetPaneInfo( 3, nID, nStyle, cxWidth);
	m_wndStatusBar.SetPaneInfo( 3, nID, SBT_OWNERDRAW, cxWidth);
	m_wndStatusBar.GetPaneInfo( 4, nID, nStyle, cxWidth);
	m_wndStatusBar.SetPaneInfo( 4, nID, SBT_OWNERDRAW, cxWidth);

//	CStatusBarCtrl& statusBarCtrl = m_wndStatusBar.GetStatusBarCtrl ();
	
/*
	statusBarCtrl.SetBorders ();
	int nParts = statusBarCtrl.GetParts (0, NULL);
	int pParts[16];
	memset (pParts, 0, 16*sizeof (int));
	statusBarCtrl.GetParts (nParts, pParts);
*/
	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT /*lpcs*/,
	CCreateContext* pContext)
{
	// create splitter window
	if (!m_wndSplitter.CreateStatic(this, 1, 2))
		return FALSE;

	if (!m_wndSplitter.CreateView(0, 0, RUNTIME_CLASS(CMarkersView), CSize(350, 300), pContext) ||
		!m_wndSplitter.CreateView(0, 1, RUNTIME_CLASS(CMarkersView), CSize(350, 300), pContext))
	{
		m_wndSplitter.DestroyWindow();
		return FALSE;
	}

	CMarkersView* pLeftView = DYNAMIC_DOWNCAST(CMarkersView, m_wndSplitter.GetPane(0,0));
	pLeftView->m_bLeft = TRUE;
	CMarkersView* pRightView = DYNAMIC_DOWNCAST(CMarkersView, m_wndSplitter.GetPane(0,1));
	pRightView->m_bLeft = FALSE;

	SetActiveView((CView*)m_wndSplitter.GetPane(0,0));

	return TRUE;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

CMarkersView* CMainFrame::GetRightPane()
{
	CWnd* pWnd = m_wndSplitter.GetPane(0, 1);
	CMarkersView* pView = DYNAMIC_DOWNCAST(CMarkersView, pWnd);
	return pView;
}

CMarkersView* CMainFrame::GetLeftPane()
{
	CWnd* pWnd = m_wndSplitter.GetPane(0, 0);
	CMarkersView* pView = DYNAMIC_DOWNCAST(CMarkersView, pWnd);
	return pView;
}

void CMainFrame::OnMarkersTogglebookmark() 
{
	CMarkersView* pView = (CMarkersView*)GetActiveView ();
	if (pView != NULL)
	{
		ASSERT_VALID (pView);
		pView->OnMarkersTogglebookmark ();
	}
}

void CMainFrame::OnMarkersNextbookmark() 
{
	CMarkersView* pView = (CMarkersView*)GetActiveView ();
	if (pView != NULL)
	{
		ASSERT_VALID (pView);
		pView->OnMarkersNextbookmark ();
	}
}

void CMainFrame::OnMarkersPreviousbookmark() 
{
	CMarkersView* pView = (CMarkersView*)GetActiveView ();
	if (pView != NULL)
	{
		ASSERT_VALID (pView);
		pView->OnMarkersPreviousbookmark ();
	}
}

void CMainFrame::OnMarkersTogglebreakpoint() 
{
	CMarkersView* pView = (CMarkersView*)GetActiveView ();
	if (pView != NULL)
	{
		ASSERT_VALID (pView);
		pView->OnMarkersTogglebreakpoint ();
	}
}

void CMainFrame::OnMarkersRemoveAllBreakpoints() 
{
	CMarkersView* pView = (CMarkersView*)GetActiveView ();
	if (pView != NULL)
	{
		ASSERT_VALID (pView);
		pView->OnMarkersRemoveAllBreakpoints ();
	}
}

void CMainFrame::OnEditFind() 
{
	CMarkersView* pView = (CMarkersView*)GetActiveView ();
	if (pView != NULL)
	{
		ASSERT_VALID (pView);
		pView->OnEditFind ();
	}
}

void CMainFrame::OnEditFindnext() 
{
	CMarkersView* pView = (CMarkersView*)GetActiveView ();
	if (pView != NULL)
	{
		ASSERT_VALID (pView);
		pView->OnEditFindnext ();
	}
}

void CMainFrame::OnEditFindprev() 
{
	CMarkersView* pView = (CMarkersView*)GetActiveView ();
	if (pView != NULL)
	{
		ASSERT_VALID (pView);
		pView->OnEditFindprev ();
	}
}

void CMainFrame::OnMarkersToggleStaticmarker() 
{
	CMarkersView* pView = (CMarkersView*)GetActiveView ();
	if (pView != NULL)
	{
		ASSERT_VALID (pView);
		pView->OnMarkersToggleStaticmarker ();
	}
}

void CMainFrame::OnMarkersFullline() 
{
	CMarkersView* pViewLeft = GetLeftPane ();
	CMarkersView* pViewRight = GetRightPane ();

	ASSERT_VALID (pViewLeft);
	ASSERT_VALID (pViewRight);

	CCustomEditCtrl* pWndEditLeft = (CCustomEditCtrl*)pViewLeft->GetEditCtrl ();
	CCustomEditCtrl* pWndEditRight = (CCustomEditCtrl*)pViewRight->GetEditCtrl ();

	ASSERT_VALID (pWndEditLeft);
	ASSERT_VALID (pWndEditRight);

	BOOL bFullLine = !pWndEditLeft->IsEnableFullLine ();
	pWndEditLeft->EnableFullLine (bFullLine);
	pWndEditRight->EnableFullLine (bFullLine);
}

void CMainFrame::OnUpdateMarkersFullline(CCmdUI* pCmdUI) 
{
	CMarkersView* pView = (CMarkersView*)GetActiveView ();
	if (pView != NULL)
	{
		ASSERT_VALID (pView);

		CCustomEditCtrl* pWndEdit = (CCustomEditCtrl*)pView->GetEditCtrl ();
		ASSERT_VALID (pWndEdit);

		pCmdUI->SetCheck (pWndEdit->IsEnableFullLine ());
	}
}

void CMainFrame::OnMarkersLinemarker() 
{
	CMarkersView* pView = (CMarkersView*)GetActiveView ();
	if (pView != NULL)
	{
		ASSERT_VALID (pView);

		CCustomEditCtrl* pWndEdit = (CCustomEditCtrl*)pView->GetEditCtrl ();
		ASSERT_VALID (pWndEdit);

		pWndEdit->EnableLineMarker (!pWndEdit->IsEnableLineMarker ());
	}
}

void CMainFrame::OnUpdateMarkersLinemarker(CCmdUI* pCmdUI) 
{
	CMarkersView* pView = (CMarkersView*)GetActiveView ();
	if (pView != NULL)
	{
		ASSERT_VALID (pView);

		CCustomEditCtrl* pWndEdit = (CCustomEditCtrl*)pView->GetEditCtrl ();
		ASSERT_VALID (pWndEdit);

		pCmdUI->SetCheck (pWndEdit->IsEnableLineMarker ());
	}
}

void CMainFrame::OnMarkersNextdiff() 
{
	CMarkersView* pView = (CMarkersView*)GetActiveView ();
	if (pView != NULL)
	{
		ASSERT_VALID (pView);
		pView->OnMarkersNextdiff ();
	}
}

void CMainFrame::OnMarkersPrevdiff() 
{
	CMarkersView* pView = (CMarkersView*)GetActiveView ();
	if (pView != NULL)
	{
		ASSERT_VALID (pView);
		pView->OnMarkersPrevdiff ();
	}
}

void CMainFrame::OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
	if (nIDCtl == AFX_IDW_STATUS_BAR)
	{
		CDC* pDC = CDC::FromHandle (lpDrawItemStruct->hDC);
		ASSERT_VALID (pDC);

		CRect rect (lpDrawItemStruct->rcItem);

		COLORREF clrDeleted		= RGB (0, 0, 255);
		COLORREF clrBkDeleted	= RGB (192, 192, 192);
		COLORREF clrChanged		= RGB (255, 0, 0);
		COLORREF clrBkChanged	= RGB (192, 192, 192);
		COLORREF clrInserted	= RGB (0, 128, 0);
		COLORREF clrBkInserted	= RGB (192, 192, 192);

		if (lpDrawItemStruct->itemID == 2)
		{
			COLORREF clrOld = pDC->SetTextColor (clrDeleted);
			COLORREF clrBkOld = pDC->SetBkColor (clrBkDeleted);

			pDC->FillSolidRect (&rect, clrBkDeleted);

			CString str;
			str.LoadString (ID_INDICATOR_DELETED);
			pDC->DrawText (str, &rect, DT_CENTER | DT_SINGLELINE);

			pDC->SetTextColor (clrOld);
			pDC->SetBkColor (clrBkOld);
		}
		else if (lpDrawItemStruct->itemID == 3)
		{
			COLORREF clrOld = pDC->SetTextColor (clrChanged);
			COLORREF clrBkOld = pDC->SetBkColor (clrBkChanged);

			pDC->FillSolidRect (&rect, clrBkChanged);

			CString str;
			str.LoadString (ID_INDICATOR_CHANGED);
			pDC->DrawText (str, &rect, DT_CENTER | DT_SINGLELINE);

			pDC->SetTextColor (clrOld);
			pDC->SetBkColor (clrBkOld);
		}
		else if (lpDrawItemStruct->itemID == 4)
		{
			COLORREF clrOld = pDC->SetTextColor (clrInserted);
			COLORREF clrBkOld = pDC->SetBkColor (clrBkInserted);

			pDC->FillSolidRect (&rect, clrBkInserted);

			CString str;
			str.LoadString (ID_INDICATOR_INSERTED);
			pDC->DrawText (str, &rect, DT_CENTER | DT_SINGLELINE);

			pDC->SetTextColor (clrOld);
			pDC->SetBkColor (clrBkOld);
		}

		return;
	}
	
	CFrameWnd::OnDrawItem(nIDCtl, lpDrawItemStruct);
}
